#ifndef _ERRORCODE_H_
#define _ERRORCODE_H_

#include "DataType.h"
//#define DEBUG

// Levels of output info dumping
enum {QUIET, INFO, DEBUG};


#define ErrorCode           UInt32

/**
 *  for general use
 */
#define NOERROR             0
#define GENERAL_ERROR       1
#define MEM_ALLOC_FAILED    2
#define INVALID_PARAM       3
#define ARRAY_EMPTY         4
#define OPERATION_FAILED    5

/**
 * SuffixArray
 */
#define MATCH_NOT_FOUND     101
#define PARTIAL_MATCH       102

/**
 * LCP
 */
#define LCP_COMPACT_FAILED  201


/**
 * W_msufsort
 */



/**
 * W_kasai_lcp
 */

#define CHECKERROR(i)       {									                        \
	if((i) != NOERROR) {										                            \
		std::cout << "[CHECKERROR()]  Error! Code: " << (i) << std::endl; \
		exit(EXIT_FAILURE);										                            \
	}															                                      \
}


#define MESSAGE(msg) { std::cout<<(msg)<<std::endl; }

#endif
